Loading...
Searching...
No Matches
Opm::MiscibleMultiPhaseComposition< Scalar, FluidSystem, Evaluation > Class Template Reference

Computes the composition of all phases of a N-phase, N-component fluid system assuming that all N phases are present. More...

`#include <MiscibleMultiPhaseComposition.hpp>`

## Static Public Member Functions

template<class FluidState, class ParameterCache>
static void | solve (FluidState &fluidState, ParameterCache &paramCache, int phasePresence, const MMPCAuxConstraint< Evaluation > *auxConstraints, unsigned numAuxConstraints, bool setViscosity, bool setInternalEnergy)
| Computes the composition of all phases of a N-phase, N-component fluid system assuming that all N phases are present.
template<class FluidState, class ParameterCache>
static void | solve (FluidState &fluidState, ParameterCache &paramCache, bool setViscosity, bool setInternalEnergy)
| Computes the composition of all phases of a N-phase, N-component fluid system assuming that all N phases are present.

## Detailed Description

template<class Scalar, class FluidSystem, class Evaluation = Scalar>
class Opm::MiscibleMultiPhaseComposition< Scalar, FluidSystem, Evaluation >

Computes the composition of all phases of a N-phase, N-component fluid system assuming that all N phases are present.

The constraint solver assumes the following quantities to be set:

- temperatures of all phases
- saturations of all phases
- pressures of all phases

It also assumes that the mole/mass fractions of all phases sum up to 1. After calling the solve() method the following quantities are calculated in addition:

- temperature of all phases
- density, molar density, molar volume of all phases
- composition in mole and mass fractions and molarities of all phases
- mean molar masses of all phases
- fugacity coefficients of all components in all phases
- if the setViscosity parameter is true, also dynamic viscosities of all phases
- if the setInternalEnergy parameter is true, also specific enthalpies and internal energies of all phases

## Member Function Documentation

## solve() [1/2]

template<class Scalar, class FluidSystem, class Evaluation = Scalar>
template<class FluidState, class ParameterCache>

void Opm::MiscibleMultiPhaseComposition< Scalar, FluidSystem, Evaluation >::solve | ( | FluidState & | fluidState,
|  | ParameterCache & | paramCache,
|  | bool | setViscosity,
|  | bool | setInternalEnergy )

inline static

Computes the composition of all phases of a N-phase, N-component fluid system assuming that all N phases are present.

This is a convenience method where no auxiliary constraints are used.

## solve() [2/2]

template<class Scalar, class FluidSystem, class Evaluation = Scalar>
template<class FluidState, class ParameterCache>

void Opm::MiscibleMultiPhaseComposition< Scalar, FluidSystem, Evaluation >::solve | ( | FluidState & | fluidState,
|  | ParameterCache & | paramCache,
|  | int | phasePresence,
|  | const MMPCAuxConstraint< Evaluation > * | auxConstraints,
|  | unsigned | numAuxConstraints,
|  | bool | setViscosity,
|  | bool | setInternalEnergy )

inline static

Computes the composition of all phases of a N-phase, N-component fluid system assuming that all N phases are present.

The constraint solver assumes the following quantities to be set:

- temperatures of all phases
- saturations of all phases
- pressures of all phases

It also assumes that the mole/mass fractions of all phases sum up to 1. After calling the solve() method the following quantities are calculated in addition:

- temperature of all phases
- density, molar density, molar volume of all phases
- composition in mole and mass fractions and molarities of all phases
- mean molar masses of all phases
- fugacity coefficients of all components in all phases
- if the setViscosity parameter is true, also dynamic viscosities of all phases
- if the setInternalEnergy parameter is true, also specific enthalpies and internal energies of all phases

The documentation for this class was generated from the following file:

- opm/material/constraintsolvers/MiscibleMultiPhaseComposition.hpp